#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#ifdef WIN32
#define strncasecmp strnicmp
#define RAND
#endif

/*
 * Denpa Jack(denpa.c)--Osaka-ben converter extended filter.
 *   by saitou@ta2.so-net.ne.jp http://www02.so-net.ne.jp/~saitou/
 *
 * denpa [input-file] [-b] [-r] [-t/-T] [-c] [-s] [-q] [-999] [-v] [-u] [-o]
 *       [-f dict-file] [-w output-file]
 *
 * [ǽ]
 *   Ѵĥե륿
 *
 * [ưץ]
 *  -b : ѴĽ<b>ܡ</b>ǳ롣ѴĽĴǥХåκݤ
 *  -r : ѴĽ<ruby></ruby>ǳ롣Ӥ˿ΤѴʸ
 *  -t : ѴĽ<font TITLE="ȥ°"></font>ǳ롣
 *       ȥ˿ΤѴΡ֥ȥ°ס
 *  -T : ѴĽ<font TITLE="ȥ°(Ѵʸ)"></font>ǳ롣
 *       ȥ˿ΤѴΡ֥ȥ°(Ѵʸ)ס
 *  -c : ѴĽֻѴ{ǽ}
 *  -s : SORTѤ߼ȤȤԤʤʬ®
 *  -q : ®̵Ȥʤޤ
 *  -999 : 999ϼιܿºݤ礭и̩ͤǤʤƤ褤ǡɤߤʤʬ®
 *  -v : СϤޤΥץꤷѴϹԤޤ
 *  -o : Ķѿ"OSAKA"鼭եޤ
 *  -u : ˡꡣθ³ͤȤäƥࡦɤޤ
 *  -f : եλꡣ꤬ʤХȥǥ쥯ȥ¸ߤ"denpa.dic"
 *       Ķѿ"DENPA"˻ꤷƤ褤
 *  -w : ϥե̾λꡣǥեȤǤɸϡ
 *
 * [ѥ]
 *   cc denpa.c -o denpa
 *
 * []
 *  "Denpa Jack" Ѵե륿˥֤ǽĥΤǤ
 *   ɸϤѴɸϤǤФޤ
 *       1) cat source.txt | denpa -f denpa.dic > kekka.txt
 *       2) cat source.htm | denpa -b -f denpa.dic > kekka.html
 *       3) cat source.htm | denpa -b -r -t -f denpa.dic > kekka.html
 *   ѴϳեΰʲǤ֤˺줺ˡ
 *       Ѵʸ[TAB]Ѵʸ[CR]
 *       Ѵʸ[TAB]Ѵʸ[CR]
 *       Ѵʸ[TAB]Ѵʸ[CR]
 *   ȥ°򿶤ϡ裳ѥ᡼ɬפǤ
 *       Ѵʸ[TAB]Ѵʸ[TAB]ȥ°[CR]
 *       Ѵʸ[TAB]Ѵʸ[TAB]ȥ°[CR]
 *       Ѵʸ[TAB]Ѵʸ[TAB]ȥ°[CR]
 *   ѴSORTƤɬϤޤ󤬡SORTƤäư®⡣
 *   HTMLΥ򤱤åȤ߹Ǥޤ
 *       򤱤뤳Ȥǥե٥åȤѴǽˤʤޤ
 *     ʤΤޤѴȥξޤǽ񤭴Ƥޤ礬뤿
 *       򤱤뤳Ȥ<b>Ĵ</b>ꤹ뤳ȤǤޤ
 *     <title></title>ΥǤѴϤޤ<b></b>Ϳޤ
 *   ѴʸƱξ֤ǽǤ
 *       )
 *       Ǥ[tab]Ǥ[CR]
 *       Ǥ[tab]Ǥ͡[CR]     Τ줫֤
 *       Ǥ[tab]Ǥʡ[CR]
 *
 * [­]
 *   "Denpa Jack" ΤHTML󥸥ܤƤޤñʤե륿Ǥ
 *   ΤۡڡѴCGI硢HTML󥸥ɬפǤ
 *       Perl CGIιˡˤĤƤϡֳ١פΥڡ򻲹ͤˤȤ褤Ǥ礦
 *           http://www.ash.or.jp/~take/osaka/
 *       DelegateȤäץͳѴιۤϡYanפΥڡͤˤʤޤ
 *           http://www.yorosiku.net/yan/osakaproxy.html
 *
 * [ưǧ]
 *   AIX Version 4.3(IBM RS/6000)
 *   SunOS 5.5(SunMicrosystems SUN4M SPARC)
 *   Linux 2.2.12(Red Had 6.1J)
 *
 * []
 *   2000/03/21 Ū˽ľ
 *   2000/07/24 Ӥ򿶤뵡ǽɲ
 *   2000/07/28 ȥ°򿶤뵡ǽɲ
 *   2000/08/15 ɥʬ㴳
 *   2000/09/01 ȥ°Ѵʸ򿶤뵡ǽɲ
 *   2000/09/12 nofilterб˳줿ΰѴоݳȤʤޤ
 *   2000/09/26 ѴĽֻѴ뵡ǽɲ
 *   2001/08/31 ŬθƤSORTѤ߼ȼνͻεǽɲá
 *   2001/09/04 եĶѿǻ褦ѹ
 *   2001/09/05 ϥե褦ѹ
 *   2001/09/06 ϥե褦ѹ
 *   2001/09/10 ˺Ŭstringϴؿmemoryϴؿ֤
 *   2002/02/15 С䤤碌Ķѿ"OSAKA"бʬڸΥХ
 *
 */

typedef unsigned char mchar;
typedef struct /*  */
{
    mchar  *inp_str;
    int     inp_len;
    mchar  *out_str;
    int     out_len;
    mchar  *title_str;
    int     title_len;
    int     cnt;
    int     tail_pos;
    mchar   tail_byte;
}   ST_DICT;     

static int loaddict(mchar p_file_nm[]);
static int qsort_compare(ST_DICT *, ST_DICT *);
static int line_count(mchar p_file_nm[]);
static int indexing();
static int convert(mchar p_inp_nm[], mchar p_out_nm[]);
static int convertword(mchar p_out_str[], mchar p_inp_str[], int p_inp_len);
static int convertquick(mchar p_out_str[], mchar p_inp_str[], int p_inp_len);
static ST_DICT *getdict(mchar p_str[]);

mchar      *kd_ver      = "1.12";        /* С */
mchar      *kd_usage    = "Usage: denpa [option]... [filename]...\n"; /* Ȥ */
mchar      *kd_inp_nm   = NULL;          /* ϥե̾ */
mchar      *kd_out_nm   = NULL;          /* ϥե̾ */
mchar      *kd_dict_nm  = NULL;          /* ե̾ */

int         kd_bold     = 0;             /* Ĵ뤫 */
int         kd_ruby     = 0;             /* Ӥ򿶤뤫 */
int         kd_title    = 0;             /* ȥ򿶤뤫 */
int         kd_colour   = 0;             /* դ */
int         kd_sort     = 0;             /* ȺѤ */
int         kd_quick    = 0;             /* ®Ѵ */
int         kd_uniq     =-1;             /* ࡦ */

int         kd_dict_cnt = 0;             /* ǡΥ */
ST_DICT    *kd_dict_tbl = NULL;          /* ǡΥݥ */
int         kd_dict_idx[256+1];          /* ǡΥǥå */
int         kd_dict_len[256];            /* ûʸĹ */

/***
 * ᥤ
 ***/
int main(int argc, char *argv[])
{
    int     i;
    int     ret;


    /* Ķѿ鼭ե̾μ */
    kd_dict_nm = getenv("DENPA");
    if (kd_dict_nm==NULL)
    {
        kd_dict_nm = "./denpa.dic";
    }

    /* ưץȽ */
    for(i=1; i<argc; i++)
    {
        if (argv[i][0]=='-')
        {
            switch(argv[i][1])
            {
            case 'b':
                kd_bold=1;
                continue;

            case 'r':
                kd_ruby=1;
                continue;

            case 't':
                kd_title=1;
                continue;

            case 'T':
                kd_title=2;
                continue;

#ifdef COLOURED
            case 'c':
                kd_colour=1;
                continue;
#endif

            case 's':
                kd_sort=1;
                continue;

            case 'q':
                kd_quick=1;
                continue;

            case 'v':
                fprintf(stderr, "Denpa Jack version %s\n", kd_ver);
                exit(0);

            case 'u':
                if (isdigit(argv[i][2])) /* -u999 */
                {
                    kd_uniq = strtol(&argv[i][2], NULL, 10);
                    continue;
                }
                fprintf(stderr, kd_usage);
                exit(-1);

            case 'o':
                kd_dict_nm = getenv("OSAKA");
                if (kd_dict_nm==NULL)
                {
                    fprintf(stderr, kd_usage);
                    exit(-1);
                }
                continue;

            case 'f':
                kd_dict_nm = argv[i+1];
                if (kd_dict_nm==NULL)
                {
                    fprintf(stderr, kd_usage);
                    exit(-1);
                }
                i++;
                continue;

            case 'w':
                kd_out_nm = argv[i+1];
                if (kd_out_nm==NULL)
                {
                    fprintf(stderr, kd_usage);
                    exit(-1);
                }
                i++;
                continue;

            default:
                if (isdigit(argv[i][1])) /* -999 */
                {
                    kd_dict_cnt = strtol(&argv[i][1], NULL, 10);
                    continue;
                }
                fprintf(stderr, kd_usage);
                exit(-1);
            }
        }
        kd_inp_nm = argv[i];
    }

    /* եɤ߹ */
    ret = loaddict(kd_dict_nm);
    if (ret<0)
    {
        exit(-1);
    }

    /* Ѵᥤ */
    ret = convert(kd_inp_nm, kd_out_nm);
    if (ret<0)
    {
        exit(-1);
    }

    exit(0);
}

/*
 * եɤ߹
 */

static int loaddict(mchar p_file_nm[])
{
    int     i, j, k;
    int     w_len;
    int     w_lens;

    FILE   *w_file;
    int     w_dict_cnt;
    mchar   w_str[1024];
    mchar  *w_dup;
    ST_DICT *w_dict;


    /* Υȡʻ */
    if (kd_dict_cnt==0)
    {
        w_dict_cnt = line_count(p_file_nm);
        if (w_dict_cnt<0)
        {
            fprintf(stderr, "denpa: %s: No such file or directory\n", p_file_nm);
            return(-1);
        }
    }
    else
    {
        w_dict_cnt = kd_dict_cnt;
    }

    /* Υ */
    kd_dict_tbl = (ST_DICT *)malloc(w_dict_cnt * sizeof(ST_DICT));
    if (kd_dict_tbl==NULL)
    {
        fprintf(stderr, "denpa: %s: No such file or directory\n", p_file_nm);
        return(-1);
    }
    memset(kd_dict_tbl, 0x00, w_dict_cnt * sizeof(ST_DICT));

    /* եΥץ */
    w_file = fopen(p_file_nm, "r");
    if (w_file==NULL)
    {
        fprintf(stderr, "denpa: %s: No such file or directory\n", p_file_nm);
        return(-1);
    }

    /* ǡŸ */
    for(i=0; i<w_dict_cnt; )
    {
        /* եɤ߹ */
        if (fgets(w_str, sizeof(w_str), w_file)==NULL) break;
        if (w_str[0]=='#') continue;

        /* ǡԽ */
        w_lens = strlen(w_str);
        w_len  = w_lens - 1;
        w_str[w_len]=0x00;
        for(j=1; j<w_len; j++)
        {
            if (w_str[j]=='\t')
            {
                w_dup  = malloc(w_lens);
                memcpy(w_dup, w_str, w_lens);
                w_dup[j]=0x00;

                w_dict = &kd_dict_tbl[i];
                w_dict->inp_str   = w_dup;
                w_dict->inp_len   = j;
                w_dict->tail_byte = w_dup[ w_dict->tail_pos = j-1 ];
              /*w_dict->title_str = NULL;*/
              /*w_dict->title_len = 0;*/

                j++;
                for(k=j; k<w_len; k++)
                {
                    if (w_str[k]=='\t')
                    {
                        w_dup[k]=0x00;
                        w_dict->title_str = &w_dup[k+1];
                        w_dict->title_len = w_len-k-1;
                        break;
                    }
                }
                w_dict->out_str = &w_dup[j];
                w_dict->out_len = k-j;
              /*w_dict->cnt     = 0;*/

                j=-1;
                break;
            }
        }
        if (j>0)
        {
            fprintf(stderr, ">> %s\n", w_str);
            continue;
        }
        i++;
    }
    fclose(w_file);

    /* Υ󥿤 */
    kd_dict_cnt = i;

    /* Υ */
    if (kd_sort==0)
    {
        qsort(kd_dict_tbl, kd_dict_cnt, sizeof(ST_DICT), qsort_compare);
    }

    /* Υǥå */
    indexing();

    return(0);
}

/* Υ */
static int line_count(mchar p_file_nm[])
{
    FILE   *w_file;
    int     w_cnt;
    char    w_str[1024];


    w_file = fopen(p_file_nm, "r");
    if (w_file==NULL)
    {
        return(-1);
    }

    for(w_cnt=0; ; w_cnt++)
    {
        if (fgets(w_str, sizeof(w_str), w_file)==NULL) break;
    }
    fclose(w_file);

    return(w_cnt);
}

/* Υ */
static int qsort_compare(ST_DICT *p_dict_a, ST_DICT *p_dict_b)
{
    if (*p_dict_a->inp_str==*p_dict_b->inp_str)
    {
        return(strcmp(p_dict_a->inp_str, p_dict_b->inp_str));
    }
    else
    {
        return(*p_dict_a->inp_str - *p_dict_b->inp_str);
    }
}

/* Υǥå */
static int indexing()
{
    int     i, j;
    int     w_byte, w_len;
    int     w_to;


    /* ǥå */
    memset(kd_dict_idx, 0x00, sizeof(kd_dict_idx));
    memset(kd_dict_len, 0x00, sizeof(kd_dict_len));

    w_len  = kd_dict_tbl[0].inp_len;
    w_byte = kd_dict_tbl[0].inp_str[0];

    for(i=1; i<kd_dict_cnt; i++)
    {
        w_byte = kd_dict_tbl[i].inp_str[0];
        if (kd_dict_tbl[i-1].inp_str[0]!=w_byte)
        {
            kd_dict_idx[w_byte] = i;
            kd_dict_len[ kd_dict_tbl[i-1].inp_str[0] ] = w_len;
            w_len=kd_dict_tbl[i].inp_len;
            continue;
        }

        if (w_len > kd_dict_tbl[i].inp_len)
        {
            w_len = kd_dict_tbl[i].inp_len;
        }
    }
    kd_dict_idx[256]=kd_dict_cnt;
    kd_dict_len[w_byte]=w_len;

    /* ǥåƤʤʬΥȥߥ */
    w_to = kd_dict_tbl[0].inp_str[0];
    for(i=255; i>w_to; i--)
    {
        if (kd_dict_idx[i]==0)
        {
            kd_dict_idx[i] = kd_dict_idx[i+1];
        }
    }

    /* Ѵθ礬ƱΤ򥰥롼ײ */
    j=1;
    kd_dict_tbl[0].cnt=1;
    for(i=1; i<kd_dict_cnt; i++)
    {
        if (kd_dict_tbl[i-1].inp_len==kd_dict_tbl[i].inp_len
        &&  memcmp(kd_dict_tbl[i-1].inp_str, kd_dict_tbl[i].inp_str, kd_dict_tbl[i].inp_len)==0)
        {
            j++;
            kd_dict_tbl[i].cnt=j;
        }
        else
        {
            j=1;
            kd_dict_tbl[i].cnt=1;
        }
    }

    return(0);
}

/***
 * Ѵ
 **/

#define DEF_INPBUF_LEN (1024*16)
#define DEF_OUTBUF_LEN (1024*32)

/* ζ˶ޤΰNULLʤѴоݳʳ<B>ϲäʤ */
mchar  *kd_form_tbl[] = 
{
    "<title"    , "</title>"    , "*",
    "<script"   , "</script>"   , "*",
    "<textarea" , "</textarea>" , "*",
    "<!"        , ">"           , "*",
    "<"         , ">"           , NULL,
    "ALT=\""    , "\""          , "*",
    "VALUE=\""  , "\""          , "*",
    "TITLE=\""  , "\""          , "*",
    "<nofilter" , "</nofilter>" , NULL,
     NULL       , NULL          , NULL
};
int     kd_form_cnt;
int     kd_form_sw[256];
int     kd_form_len[256];

/* Ѵᥤ */
static int convert(mchar p_inp_nm[], mchar p_out_nm[])
{
    int     i, j, k;

    FILE   *w_inp_file;
    FILE   *w_out_file;
    mchar  *w_inp_str;
    mchar  *w_out_str;
    int     w_inp_len;
    int     w_out_len;

    static mchar w_inp_vbuf[BUFSIZ];
    static mchar w_out_vbuf[BUFSIZ];

    mchar   w_str[DEF_OUTBUF_LEN];
    int     w_prev, w_next;
    int     w_form_len;


    /* ȯν */
#ifdef RAND
    if (kd_uniq<0)
    {
        srand((unsigned)time(NULL));
    }
    else
    {
        srand((unsigned)kd_uniq);
    }
#else
    if (kd_uniq<0)
    {
        srandom((unsigned)time(NULL));
    }
    else
    {
        srandom((unsigned)kd_uniq);
    }
#endif

    /* ϸȽ */
    if (p_inp_nm==NULL)
    {
        w_inp_file = stdin;
    }
    else
    {
        w_inp_file = fopen(p_inp_nm, "r");
        if (w_inp_file==NULL)
        {
            fprintf(stderr, "denpa: Couldn't open file %s\n", p_inp_nm);
            return(-1);
        }
    }

    /* Ƚ */
    if (p_out_nm==NULL)
    {
        w_out_file = stdout;
    }
    else
    {
        w_out_file = fopen(p_out_nm, "w");
        if (w_out_file==NULL) 
        {
            fprintf(stderr, "denpa: Couldn't open file %s\n", p_out_nm);
            return(-1);
        }
    }

    /* γ */
    w_inp_str = malloc(DEF_INPBUF_LEN);
    w_out_str = malloc(DEF_OUTBUF_LEN);
    if (w_inp_str==NULL || w_out_str==NULL)
    {
        perror("malloc");
        return(-1);
    }
    setvbuf(w_inp_file, w_inp_vbuf, _IOLBF, BUFSIZ);
    setvbuf(w_out_file, w_out_vbuf, _IOFBF, BUFSIZ);

    /* ®Ѵξ */
    if (kd_quick!=0)
    {
        for(;;)
        {
            if (fgets(w_inp_str, BUFSIZ, w_inp_file)==NULL) break;
            w_out_len = convertquick(w_out_str, w_inp_str, strlen(w_inp_str));
            fwrite(w_out_str, w_out_len, 1, w_out_file);
        }
        fflush(w_out_file);
        if (w_inp_file!=stdin ) fclose(w_inp_file);
        if (w_out_file!=stdout) fclose(w_out_file);

        return(0);
    }

    /* ơ֥ν */
    for(i=0; ; i++)
    {
        if (kd_form_tbl[i]==NULL)
        {
            if ((i%3)==0)
            {
                break;
            }
            continue;
        }
        kd_form_len[i]=strlen(kd_form_tbl[i]);
    }
    kd_form_cnt = i;
    memset(kd_form_sw, 0x00, sizeof(kd_form_sw));

    /* Ѵ */
    w_next=0;
    for(;;)
    {
        if (fgets(w_inp_str, BUFSIZ, w_inp_file)==NULL) break;

        w_inp_len = strlen(w_inp_str);
        for(i=0, k=0; i<w_inp_len; )
        {
            w_prev=w_next;
            w_form_len=0;
            if((w_inp_str[i]&0x80)==0)
            {
                w_next=0;
                for(j=0; j<kd_form_cnt; j+=3)
                {
                    if (strncasecmp(&w_inp_str[i], kd_form_tbl[j], kd_form_len[j])==0)
                    {
                        if (kd_form_tbl[j+2]!=NULL)
                        {
                            kd_form_sw[j]=1;
                            w_next=1;
                        }
                        else
                        {
                            kd_form_sw[j]=2;
                            w_next=2;
                        }
                        if (w_form_len==0)
                        {
                            w_form_len=kd_form_len[j];
                        }

                        continue;
                    }

                    if (strncasecmp(&w_inp_str[i], kd_form_tbl[j+1], kd_form_len[j+1])==0)
                    {
                        if (kd_form_sw[j]!=0)
                        {
                            kd_form_sw[j]=0;
                        }
                        if (w_form_len==0)
                        {
                            w_form_len=kd_form_len[j+1]-1;
                            if (w_form_len<=0)
                            {
                                w_form_len=1;
                            }
                        }
                        continue;
                    }

                    if (kd_form_sw[j]==1)
                    {
                        w_next = 1;
                        continue;
                    }
                    if (kd_form_sw[j]==2)
                    {
                        w_next = 2;
                        continue;
                    }
                }
            }

            if((w_next!=w_prev)||(w_form_len>0))
            {
                if (k>0)
                {
                    switch(w_prev)
                    {
                    case 0:
                        w_out_len = convertword(w_out_str, w_str, k);
                        fwrite(w_out_str, w_out_len, 1, w_out_file);
                        break;
                    case 1:
                        w_out_len = convertquick(w_out_str, w_str, k);
                        fwrite(w_out_str, w_out_len, 1, w_out_file);
                        break;
                    default:
                        fwrite(w_str, k, 1, w_out_file);
                        break;
                    }
                    k=0;
                }
            }

            if (w_form_len>0)
            {
                memcpy(&w_str[k], &w_inp_str[i], w_form_len);
                k+=w_form_len;
                fwrite(w_str, k, 1, w_out_file);
                i+=k;
                k=0;

                continue;
            }

            if (w_inp_str[i]&0x80)
            {
                memcpy(&w_str[k], &w_inp_str[i], 2);
                k+=2;
                i+=2;
            }
            else
            {
                memcpy(&w_str[k], &w_inp_str[i], 1);
                k++;
                i++;
            }
        }

        switch(w_prev)
        {
        case 0:
            w_out_len = convertword(w_out_str, w_str, k);
            fwrite(w_out_str, w_out_len, 1, w_out_file);
            break;
        case 1:
            w_out_len = convertquick(w_out_str, w_str, k);
            fwrite(w_out_str, w_out_len, 1, w_out_file);
            break;
        default:
            fwrite(w_str, k, 1, w_out_file);
            break;
        }
        k=0;
    }
    fflush(w_out_file);

    /*  */
    if (w_inp_file!=stdin ) fclose(w_inp_file);
    if (w_out_file!=stdout) fclose(w_out_file);
    free(w_inp_str);
    free(w_out_str);

    return(0);
}

/* Ѵ */
static int convertword(mchar p_out_str[], mchar p_inp_str[], int p_inp_len)
{
    int     i, j;
    ST_DICT *w_dict;


    for(i=0, j=0; i<p_inp_len; )
    {
        /* ˤѴ */
        w_dict = getdict(&p_inp_str[i]);
        if (w_dict!=NULL)
        {
            if (w_dict->inp_len == w_dict->out_len
            &&  memcmp(w_dict->inp_str, w_dict->out_str, w_dict->inp_len)==0)
            {
                memcpy(&p_out_str[j], w_dict->out_str, w_dict->out_len);
                j+=w_dict->out_len;
                i+=w_dict->inp_len;
                continue;
            }
            else
            {
#ifdef COLOURED
                if (kd_colour!=0)
                {
                    memcpy(&p_out_str[j], "<font COLOR=\"RED\">", 18); j+=18;
                }
#endif
                if (kd_ruby!=0)
                {
                    memcpy(&p_out_str[j], "<ruby><rb>", 10); j+=10;
                }

                if (kd_title!=0 && w_dict->title_str!=NULL)
                {
                    memcpy(&p_out_str[j], "<font TITLE=\"", 13); j+=13;
                    memcpy(&p_out_str[j], w_dict->title_str, w_dict->title_len); j+=w_dict->title_len;
                    if (kd_title==2)
                    {
                        memcpy(&p_out_str[j], "(", 1); j++;
                        memcpy(&p_out_str[j], w_dict->inp_str, w_dict->inp_len); j+=w_dict->inp_len;
                        memcpy(&p_out_str[j], ")", 1); j++;
                    }
                    memcpy(&p_out_str[j], "\">", 2); j+=2;
                }

                if (kd_bold!=0)
                {
                    memcpy(&p_out_str[j], "<b>", 3); j+=3;
                }

                memcpy(&p_out_str[j], w_dict->out_str, w_dict->out_len);
                j+=w_dict->out_len;
                i+=w_dict->inp_len;

                if (kd_bold!=0)
                {
                    memcpy(&p_out_str[j], "</b>", 4); j+=4;
                }

                if (kd_title!=0 && w_dict->title_str!=NULL)
                {
                    memcpy(&p_out_str[j], "</font>", 7); j+=7;
                }

                if (kd_ruby!=0)
                {
                    memcpy(&p_out_str[j], "</rb><rp>(</rp><rt>", 19); j+=19;
                    memcpy(&p_out_str[j], w_dict->inp_str, w_dict->inp_len); j+=w_dict->inp_len;
                    memcpy(&p_out_str[j], "</rt><rp>)</rp></ruby>", 22); j+=22;
                }
#ifdef COLOURED
                if (kd_colour!=0)
                {
                    memcpy(&p_out_str[j], "</font>", 7); j+=7;
                }
#endif
                continue;
            }
        }

        /* ˤʤФΤޤ */
        if (p_inp_str[i]&0x80)
        {
            memcpy(&p_out_str[j], &p_inp_str[i], 2);
            j+=2;
            i+=2;
        }
        else
        {
            p_out_str[j] = p_inp_str[i];
            j++;
            i++;
        }
    }
    return(j);
}

/* Ѵ2 */
static int convertquick(mchar p_out_str[], mchar p_inp_str[], int p_inp_len)
{
    int     i, j;
    ST_DICT *w_dict;


    for(i=0, j=0; i<p_inp_len; )
    {
        /* ˤѴ */
        w_dict = getdict(&p_inp_str[i]);
        if (w_dict!=NULL)
        {
            memcpy(&p_out_str[j], w_dict->out_str, w_dict->out_len);
            j+=w_dict->out_len;
            i+=w_dict->inp_len;
            continue;
        }

        /* ˤʤФΤޤ */
        if (p_inp_str[i]&0x80)
        {
            memcpy(&p_out_str[j], &p_inp_str[i], 2);
            j+=2;
            i+=2;
        }
        else
        {
            p_out_str[j] = p_inp_str[i];
            j++;
            i++;
        }
    }

    return(j);
}

/* μ */
static ST_DICT *getdict(mchar p_str[])
{
    int     i;

    int     w_pos;
    int     w_len, w_cmp;
    int     w_from, w_to;
    int     w_start, w_stop;
    int     w_cnt, w_rand;


    w_from = kd_dict_idx[p_str[0]  ];
    w_to   = kd_dict_idx[p_str[0]+1]-1;

    /* ˸ʤ */
    if (w_from>w_to) return(NULL);

    /* ϰϤιʤ(start) */
    w_len   = kd_dict_len[ p_str[0] ];
    w_start = -1;
    w_stop  = w_to;
    for(;;)
    {
        if (w_from>w_to) break;

        w_pos = (w_from+w_to)>>1;
        w_cmp = memcmp(p_str, kd_dict_tbl[w_pos].inp_str, w_len);
        if (w_cmp<0)
        {
            w_to   = w_pos - 1;
            w_stop = w_to;
        }
        else if (w_cmp>0)
        {
            w_from = w_pos + 1;
        }
        else /* if (w_cmp==0) */
        {
            w_start = w_pos;
            w_to    = w_pos - 1;
        }
    }
    if (w_start==-1)
    {
        return(NULL);
    }

    /* ˹ʤʤߤ */
    if (kd_dict_tbl[w_start].inp_len>w_len)
    {
	w_len++;
    }

    /* ϰϤιʤ(stop) */
    w_from = w_start;
    w_to   = w_stop;
    w_stop = -1;
    for(;;)
    {
        if (w_from>w_to) break;

        w_pos = (w_from+w_to)>>1;
        w_cmp = memcmp(p_str, kd_dict_tbl[w_pos].inp_str, w_len);
        if (w_cmp<0)
        {
            w_to = w_pos - 1;
        }
        else if (w_cmp>0)
        {
            w_from  = w_pos + 1;
            w_start = w_from;
        }
        else /* if (w_cmp==0) */
        {
            w_stop = w_pos;
            w_from = w_pos + 1;
        }
    }
    if (w_stop==-1)
    {
        return(NULL);
    }

    /* 񤫤Ĺʸõ */
    w_cnt = 0;
    for(i=w_stop; i>=w_start; i-=kd_dict_tbl[i].cnt)
    {
        if (p_str[kd_dict_tbl[i].tail_pos] == kd_dict_tbl[i].tail_byte
        &&  memcmp(p_str, kd_dict_tbl[i].inp_str, kd_dict_tbl[i].inp_len)==0)
        {
            w_pos = i;
            w_cnt = kd_dict_tbl[i].cnt;
            break;
        }
    }

    switch(w_cnt)
    {
    case 0: /* ʤ */
        return(NULL);

    case 1:/* 񤢤꣱ */
        return(&kd_dict_tbl[w_pos]);

    default: /* 񤢤ʣ */
#ifdef RAND
        w_rand = rand () % w_cnt;
#else
        w_rand = random () % w_cnt;
#endif
        return(&kd_dict_tbl[w_pos - w_rand]);
    }
}
